#ifndef TOKENIZER_H
#define TOKENIZER_H

#ifdef __cplusplus
extern "C" {
#endif

#include <stdbool.h>

#include "Types.h"
#include "tokenizer/Token.h"

bool tTokenize(const char* path);
const char* tGetError();
int tGetLine();

void tResetReader();
Token tPeekToken();
Token tReadToken();
bool tReadInt16(int16* i);
bool tReadInt32(int32* i);
bool tReadInt64(int64* i);
bool tReadFloat(float* f);
const char* tReadString();
int tGetMarker();
void tReset(int marker);

#ifdef __cplusplus
}
#endif

#endif